using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record FirstPass(ExifDirectory ExifDirectory,
                        bool FastForwardMovingPictureExpertsGroupUsed,
                        MinimumYearAndPathCombined MinimumYearAndPathCombined,
                        FileHolder[] SidecarFiles)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, FirstPassSourceGenerationContext.Default.FilePath);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(FirstPass))]
public partial class FirstPassSourceGenerationContext : JsonSerializerContext
{
}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(List<FirstPass>))]
public partial class FirstPassCollectionSourceGenerationContext : JsonSerializerContext
{
}