using System.Collections.ObjectModel;
using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record MetadataGroup(bool FastForwardMovingPictureExpertsGroupUsed, FilePath FilePath, MinimumYearAndPathCombined MinimumYearAndPathCombined, ExifDirectory ExifDirectory, ReadOnlyCollection<FileHolder> SidecarFiles)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, MetadataGroupSourceGenerationContext.Default.MetadataGroup);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(MetadataGroup))]
internal partial class MetadataGroupSourceGenerationContext : JsonSerializerContext
{
}